import "dart:typed_data";

import 'package:chainwallet/src/core/coretypes/uint/UInt.dart';
import "package:chainwallet/src/core/serialized/BytesSink.dart";
import 'package:chainwallet/src/core/serialized/TypeTranslator.dart';
import 'package:chainwallet/src/core/coretypes/hash/Hash.dart';
import 'package:chainwallet/src/core/fields/Type.dart';

class Hash160Translator extends HashTranslator<Hash160> {
  Hash160 newInstance(Uint8List i) => new Hash160(i);

  int byteWidth() => 20;
}

class Hash160 extends Hash<Hash160> {
  static Hash160Translator translate = new Hash160Translator();

  Hash160(Uint8List bytes) : super(bytes, 20) {}

//  Map toJSON() =>  null;
  Uint8List toBytes() => translate.toBytes(this);
  String toHex() => translate.toHex(this);
  void toBytesSink(BytesSink to) => translate.toBytesSink(this, to);
  Map toJSON() => null;

//
//
  Type type() => Type.Hash160;
//
//  int getByteWidth() => 2;

}
