import 'dart:ffi';
import "../../../../utils/Util.dart";
import 'package:chainwallet/src/core/coretypes/hash/prefixes/Prefix.dart';

class HashPrefix implements Prefix {
  static final transactionID = new HashPrefix(0x54584E00);
  // transaction plus metadata
  static final txNode = new HashPrefix(0x534E4400);
  // account state
  static final leafNode = new HashPrefix(0x4D4C4E00);
  // inner node in tree
  static final innerNode = new HashPrefix(0x4D494E00);
  // ledger master data for signing
  static final ledgerMaster = new HashPrefix(0x4C575200);
  // inner transaction to sign
  static final txSign = new HashPrefix(0x53545800);
  // multi_sign
  static final txMultiSign = new HashPrefix(0x534D5400);
  // validation for signing
  static final validation = new HashPrefix(0x56414C00);
  // proposal for signing
  static final proposal = new HashPrefix(0x50525000);

  int uInt32;
  List<int> bytesInner;

  @override
  List<int> bytes() {
    return bytesInner;
  }

  HashPrefix(int i) {
    uInt32 = i;
    bytesInner = Util.createUint8ListFromHexString(uInt32.toRadixString(16));
  }
}
