import 'dart:core';
import "dart:typed_data";

import 'package:chainwallet/src/core/coretypes/uint/UInt.dart';
import "package:chainwallet/src/core/serialized/BytesSink.dart";
import 'package:chainwallet/src/core/serialized/TypeTranslator.dart';
import 'package:chainwallet/src/core/fields/Type.dart';

class UINTTranslator16 extends UINTTranslator<UInt16> {
  UInt16 newInstance(BigInt i) {
    return new UInt16(i);
  }

  int byteWidth() {
    return 2;
  }
}

class UInt16 extends UInt<UInt16> {
  static TypeTranslator<UInt16> translate = new UINTTranslator16();

  UInt16(BigInt value) {
    super.setValue(value);
  }

  UInt16 instanceFrom(BigInt n) {
    return new UInt16(n);
  }

  Map toJSON() => null;
  Uint8List toBytes() => null;
  String toHex() => translate.toHex(this);

  void toBytesSink(BytesSink to) {
    translate.toBytesSink(this, to);
  }

  Type type() => Type.UInt16;

  int getByteWidth() => 2;
}
