import 'dart:core';
import "dart:typed_data";

import 'package:chainwallet/src/core/coretypes/uint/UInt.dart';
import 'package:chainwallet/src/core/serialized/SerializedType.dart';

import 'package:chainwallet/src/core/serialized/BytesSink.dart';
import 'package:chainwallet/src/core/fields/Type.dart';

import 'package:chainwallet/src/core/serialized/TypeTranslator.dart';

import 'package:chainwallet/src/core/fields/Field.dart';
import 'package:chainwallet/src/core/fields/UInt32Field.dart';

class UInt32 extends UInt<UInt32> {
  static TypeTranslator<UInt32> translate = new UINTTranslator32();

  static UInt32Field Flags = new UInt32Field(Field.Flags);

  UInt32(BigInt value) {
    super.setValue(value);
  }

  Map toJSON() => null;

  Uint8List toBytes() {
    return translate.toBytes(this);
  }

  String toHex() => null;

  void toBytesSink(BytesSink to) {
    translate.toBytesSink(this, to);
  }

  Type type() => Type.UInt32;

  int getByteWidth() => 4;

  UInt32 instanceFrom(BigInt n) {
    return new UInt32(n);
  }
}

class UINTTranslator32 extends UINTTranslator<UInt32> {
  UInt32 newInstance(BigInt i) {
    return new UInt32(i);
  }

  int byteWidth() => 4;
}
