class Type {
  static final Unknown = new Type(-2);
  static final Done = new Type(-1);

  static final UInt16 = new Type(1);
  static final UInt32 = new Type(2);
  static final UInt64 = new Type(3);

  static final Hash256 = new Type(5);
  static final Amount = new Type(6);
  static final Blob = new Type(7);
  static final AccountID = new Type(8);

  static final STObject = new Type(14);
  static final STArray = new Type(15);
  static final Hash160 = new Type(17);

  static final PathSet = new Type(18);

//  Done(-1),
//  NotPresent(0),
//  UInt16(1),
//  UInt32(2),
//  UInt64(3),
//  Hash128(4),
//  Hash256(5),
//  Amount(6),
//  Blob(7),
//  AccountID(8),
//  STObject(14),
//  STArray(15),
//  UInt8(16),
//  Hash160(17),
//  PathSet(18),
//  Vector256(19),
//  Map256(29),
//  Transaction(10001),
//  LedgerEntry(10002),
//  Validation(10003);

  static Map<int, Type> _Int2Type = new Map<int, Type>();

  static bool _bInit = false;

  static Type valueOf(int integer) {
    if (!_bInit) {
      _Int2Type[-2] = Type.Unknown;
      _Int2Type[-1] = Type.Done;
      _Int2Type[1] = Type.UInt16;
      _Int2Type[2] = Type.UInt32;
      _Int2Type[3] = Type.UInt64;

      _Int2Type[5] = Type.Hash256;
      _Int2Type[6] = Type.Amount;
      _Int2Type[7] = Type.Blob;

      _Int2Type[8] = Type.AccountID;

      _Int2Type[17] = Type.Hash160;
      _Int2Type[18] = Type.PathSet;

      _bInit = true;
    }

    return _Int2Type[integer];
  }

  final int id;
  Type(int value) : id = value {}

  int getId() => id;
}
