import "../fields/Field.dart";

abstract class Format {
  void addCommonFields() {}

  Map<Field, Requirement> requirementEnumMap = new Map<Field, Requirement>();

  Map<Field, Requirement> requirements() {
    return requirementEnumMap;
  }

  String name();

  Format(List<Object> args) {
    if ((!(args.length % 2 == 0)) || args.length < 2) {
      throw new Exception("Varargs length should be a minimum multiple of 2");
      //  throw new IllegalArgumentException("Varargs length should be a minimum multiple of 2");
    }
    for (int i = 0; i < args.length; i += 2) {
      Field f = args[i] as Field;
      Requirement r = args[i + 1] as Requirement;
      put(f, r);
    }
  }

  void put(Field f, Requirement r) {
    requirementEnumMap[f] = r;
  }
}

enum Requirement { INVALID, REQUIRED, OPTIONAL, DEFAULT }
