import "dart:typed_data";
import "dart:core";
import "./BytesSink.dart";

class BytesList implements BytesSink {
  List<List<int>> buffer = new List<List<int>>();

  int len = 0;

  static List<String> hexLookup = new List<String>(256);
  BytesList() {
    for (int i = 0; i < 256; i++) {
      String s = i.toRadixString(16).toUpperCase();
      if (s.length == 1) {
        s = "0" + s;
      }
      hexLookup[i] = s;
    }
  }

  @override
  void addByte(int aByte) {
    List<int> list = new List<int>(1);
    list.add(aByte);

    addBytes(list);
  }

  @override
  void addBytes(Uint8List bytes) {
    len += bytes.length;
    buffer.add(bytes);
  }

  int get8(int offset) {
    if (offset + 1 > len) {
      return -1;
    }
    return bytes()[offset] & 0xff;
  }

  Uint8List bytes() {
    int n = bytesLength();
    Uint8List bytes = new Uint8List(n);
    addBytesInner(bytes);
    return bytes;
  }

  String bytesHex() {
    String builder = "";
    for (List<int> buf in buffer) {
      for (int aBytes in buf) {
        var str = hexLookup[aBytes & 0xFF];

        builder = builder + str;
      }
    }
    return builder;
  }

  int bytesLength() {
    return len;
  }

  void addBytesInner(Uint8List bytes) {
    int pos = 0;
    for (List<int> buf in buffer) {
      for (var byte in buf) {
        bytes[pos++] = byte;
      }
    }
  }

  List<List<int>> rawList() {
    return buffer;
  }
}
