import "dart:typed_data";

import "./BytesSink.dart";

class MultiSink implements BytesSink {
  List<BytesSink> sinks;

  MultiSink(List<BytesSink> sinks) {
    this.sinks = sinks;
  }

  void addByte(int aByte) {
    for (BytesSink sink in sinks) sink.addByte(aByte);
  }

  void addBytes(Uint8List bytes) {
    for (BytesSink sink in sinks) sink.addBytes(bytes);
  }
}
