import 'dart:convert';
import 'dart:typed_data';

import 'package:chainwallet/src/model/wallet.dart';
import 'package:test/test.dart';
import 'package:chainwallet/chainwallet.dart';
import 'package:chainwallet/src/utils/Util.dart';

void testRef(Uint8List buff) {
  if (buff.length == 1) {
    buff[0] = 10;
  }
}

void main() {
  test('Chainsql generateAddress', () {
    var walletInfo = Chainsql.generateAddress();
    String jsonStr = json.encode(walletInfo);
    print(jsonStr);

    //var walletIn  = wallet.fromJson(json.decode(jsonStr));
    var walletMap = walletInfo.toJson();
    expect(walletMap.containsKey("address"), true);
    expect(walletMap.containsKey("secret"), true);
    expect(walletMap.containsKey("publicKey"), true);

    var walletFromSeed =
        Chainsql.generateAddressFromStr("xpkpdVP3LKhtdSfQX3uHNs1f7jN42");

    var walletFromSeedMap = walletFromSeed.toJson();
    expect(walletFromSeedMap.containsKey("address"), true);
    expect(walletFromSeedMap.containsKey("secret"), true);
    expect(walletFromSeedMap.containsKey("publicKey"), true);

    expect(walletFromSeedMap["address"], "zKa9fxNT4KJwya73M4TYiCKxCQv97511Ve");
    expect(walletFromSeedMap["secret"], "xpkpdVP3LKhtdSfQX3uHNs1f7jN42");
    expect(walletFromSeedMap["publicKey"],
        "cB4e4YpAbPTLyYHmHmEBpLHCNU9TQc8jBUgERoAoQJBkhxT5fRfw");
  });
}
